#include <iostream>

#include "ko/Connection.hpp"

using namespace std;

namespace ko
{

void print(Connection &c)
{
  cout << "Connection:" << endl;
  cout << "element1: " << c.element1->name << endl;
  cout << "element2: " << c.element2->name << endl;
}


void Connection::connect(Element &e1, Element &e2)
{
  // reminder, stupid mistake to connect the same elements twice
  if(e1.isConnected(e2))
  {
    cerr << "Two connections between the same elements detected" << endl;
    return;
  }

  element1 = &e1;
  element2 = &e2;

  e1.connections.push_back(this);
  e2.connections.push_back(this);
}

void Connection::disconnect()
{
  if(element1 != 0 && element2 != 0)
    {
      element1->connections.remove(this);
      element2->connections.remove(this);
    }

  element1 = 0;
  element2 = 0;
}

}

