#include <iostream>

#include "ko/Element.hpp"
#include "ko/Connection.hpp"

using namespace std;

namespace ko
{

void print(Element &e)
{
  std::cout << "Element:" << endl;
  std::cout << "name: " << e.name << endl;
  //std::cout << "mass: " << e.mass << endl;
  std::cout << "position: " <<
    e.position(0) << " " <<
    e.position(1) << " " <<
    e.position(2) << " " <<
    endl;
  std::cout << "velocity: " <<
    e.velocity(0) << " " <<
    e.velocity(1) << " " <<
    e.velocity(2) << " " <<
    endl;


}

Element::Element() : position(3), velocity(3), position0(3), velocity0(3),
		     force(3), force0(3), force_fe(3), radius(1),
		     artificial(false),
		     material(0), index(0)
{
}

bool Element::isConnected(Element &e)
{
  for(list<Connection *>::iterator i = connections.begin();
      i != connections.end(); i++)
    {
      Connection &c = **i;
      
      if(c.element1 == &e || c.element2 == &e)
	{
	  return true;
	}
    }
  return false;
}

Connection *Element::getConnection(Element &e)
{
  for(list<Connection *>::iterator i = connections.begin();
      i != connections.end(); i++)
    {
      Connection *c = *i;
      
      if(c->element1 == &e || c->element2 == &e)
	{
	  return c;
	}
    }
  return 0;
}


}

