#include <stdio.h>

#include <iostream>
#include <iomanip>
#include <map>

#include <sys/time.h>

#include "ko/LinAlg.hpp"

using namespace std;

namespace ko
{

void bbox(list<Vector *> points, Vector &min, Vector &max)
{
  for(list<Vector *>::iterator it = points.begin();
      it != points.end(); it++)
  {
    Vector &v = **it;

    if(it == points.begin())
    {
      min = v;
      max = v;
    }
    else
    {
      for(int i = 0; i < v.size(); i++)
      {
	if(v(i) < min(i))
	  min(i) = v(i);
	if(v(i) > max(i))
	  max(i) = v(i);
      }
    }
  }  
}

int CGSolve(Matrix &A, LargeVector &x, LargeVector &b, double tolerance,
	    int maxiters)
{ 
  using namespace dolfin;

  GMRES solver;
  solver.solve(A, x, b);

  return 0;
}

void cross(Vector &v1, Vector &v2, Vector &result)
{
  result(0) = v1(1) * v2(2) - v1(2) * v2(1);
  result(1) = v1(0) * v2(2) - v1(2) * v2(0);
  result(2) = v1(0) * v2(1) - v1(1) * v2(0);
}



}

