#if !defined(BSPTREE_H)
#define BSPTREE_H

#include <list>

#include "ko/LinAlg.hpp"
#include "ko/Element.hpp"

//using namespace std;

namespace ko
{

class BSPTree;


class BSPTree
{
 protected:
  // Randomized-Partition and Partition from quicksort for quickselect
  //int QS_Rand_Partition( double *A, int p, int r );
  //int QS_Partition( double *A, int p, int r );
  //double QS_Rand_Select( double *A, int p, int r, int i );

 public:
  enum orient_types
  {
    X_PARTITION = 1, Y_PARTITION, Z_PARTITION
  };

  Vector	       center, min, max;
  std::list<Element *>      data;
  BSPTree	       *lt_child, *geq_child, *parent;
  int		       level;
  orient_types	       orientation;

  std::list<BSPTree *>      *pool;

  BSPTree( std::list<BSPTree *> *alloc_pool );
  BSPTree( BSPTree *cptree, std::list<BSPTree *> *alloc_pool );
  ~BSPTree();

  void			Partition(std::list<Element *> &set);
  void			Collide(Element &e,
				std::list<Element *> &collisions );
  //double		Median( double *A, int n );

  static BSPTree *	pool_alloc_bsptree( std::list<BSPTree *> *pool );
  static void		pool_free_bsptree( BSPTree *tree,
					   std::list<BSPTree *> *pool);
  
protected:
  void computeCenter();
};



}

#endif
