#if !defined(COLLISIONDETECTOR_HPP)
#define COLLISIONDETECTOR_HPP

#include <list>
#include "ko/LinAlg.hpp"
#include "ko/Element.hpp"
#include "ko/Connection.hpp"
#include "ko/Physical.hpp"
#include "ko/MechanicsModel.hpp"
#include "ko/BSPTree.hpp"

namespace ko
{

class IntersectionDetector
{
public:
  IntersectionDetector();

  std::list<Element *> elements;

  BSPTree *spacetree1;

  std::list<BSPTree *> *spacetree1_pool;


  void init(std::list<Element *> &targets);

  void buildTrees();
  void intersectionList(Element &e1, std::list<Element *> &intersections);

  bool isIntersection(Element &e1, Element &e2);
};

}


#endif // PHYSICAL_HPP
