#if !defined(LINALG_HPP)
#define LINALG_HPP

#include <complex>
#include <list>

#include "ko/SimpleVector.hpp"

#include <dolfin/Vector.h>
#include <dolfin/Matrix.h>
#include <dolfin/GMRES.h>

//using namespace std;
namespace ko
{
  typedef dolfin::Matrix Matrix;
  typedef SimpleVector Vector;

  typedef dolfin::Vector LargeVector;

  void bbox(std::list<Vector *> points, Vector &min, Vector &max);

  int CGSolve(Matrix &A, LargeVector &x, LargeVector &b, double tol,
	      int maxiters);
  
  void cross(Vector &v1, Vector &v2, Vector &result);
}

#endif // LINALG_HPP

