#if !defined(MECHANICSMODEL_HPP)
#define MECHANICSMODEL_HPP

#include <list>
#include "ko/Material.hpp"
#include "ko/Element.hpp"
#include "ko/Connection.hpp"

namespace ko
{

extern long long fcount;

class MechanicsModel
{
public:
  Vector g;

  MechanicsModel();

  void force(Element &e, Vector &f);
  void force(Element &e, Element &e2, Vector &f);
  void force(Connection &c, Element &e, Vector &f);

  void plasticity(Connection &c);
  void fracture(Connection &c);

  static double hooke(Connection &c);
  static double damp(Connection &c);
  static double mass(Element &e);
};

}

#endif // PHYSICAL_HPP

