
#if !defined(PHYSICAL_HPP)
#define PHYSICAL_HPP

#include <list>
#include "ko/Material.hpp"
#include "ko/Element.hpp"
#include "ko/Connection.hpp"

//#include "ko/PhysicalWatcher.hpp"
//#include "ko/PhysicalManipulator.hpp"

namespace ko
{

class PhysicalWatcher;
class PhysicalManipulator;


class Physical
{
public:
  std::list<Material *> materials;
  std::list<Element *> elements;
  std::list<Connection *> connections;

  std::list<PhysicalWatcher *> watchers;
  std::list<PhysicalManipulator *> manipulators;

  void addElement(Element &e);
  void removeElement(Element &e);
  void addConnection(Connection &c);
  void removeConnection(Connection &c);

  void manipulate();

  void merge(Physical &p);

  int dof();
};

void print(Physical &);
void generateNames(Physical &);

}


#endif // PHYSICAL_HPP

