#if !defined(PHYSICALDOLFININTERFACE_HPP)
#define PHYSICALDOLFININTERFACE_HPP

#include <iostream>
#include <vector>

#include <dolfin.h>

#include "ko/LinAlg.hpp"
#include "ko/Element.hpp"
#include "ko/Connection.hpp"
#include "ko/Material.hpp"
#include "ko/Physical.hpp"

namespace ko
{

class PhysicalDolfinInterface
{
public:
  PhysicalDolfinInterface(dolfin::Mesh& mesh, Physical& physical,
			  dolfin::Function& velocity, dolfin::real young,
			  dolfin::real damp);

  void updatePhysical();
  void build();
  void addNode(dolfin::Node& node);
  void addCell(dolfin::Cell& cell);
  void addBoundaryCell(dolfin::Face& cell);
  void updateNode(dolfin::Node& node);

  dolfin::Mesh& mesh;
  dolfin::Boundary boundary;
  dolfin::Function& velocity;
  Physical& physical;

  Material m;

  std::vector<Element *> elements;
  std::vector<dolfin::Node *> nodes;
};

}

#endif // PHYSICAL_HPP
