// Copyright (C) 2003 Johan Jansson.
// Licensed under the GNU GPL Version 2.
//
// Modified by Anders Logg, 2004.

#include <iostream>
#include "ko/MultiAdaptiveIntegrator.hpp"

using namespace std;
using namespace ko;

MultiAdaptiveIntegrator::MultiAdaptiveIntegrator(Physical &physical,
						 double duration) :
  NumericalIntegrator(physical), n(physical.dof()),
  dolfin::ODE(physical.dof(), duration), k(physical.dof()), U0(physical.dof()),
  timestepper(0)
{
//   cerr << "dof: " << physical.dof() << endl;
//   cerr << "n: " << n << endl;
//   cerr << "N: " << N << endl;

//   dynamicElements.clear();
//   for(list<Element *>::iterator it = physical.elements.begin();
//       it != physical.elements.end(); it++)
//   {
//     Element &e = **it;
      
//     if(!e.artificial)
//       dynamicElements.push_back(&e);
//   }

//   updateLookups();

//   T = duration;

//   toArray(U0);
//   U1 = U0;
  
//   k = dolfin::dolfin_get("initial time step");

//   U.init(n);
//   U.rename("u", "primal");

//   //timestepper = new dolfin::TimeStepper(*this, U);

//   //sparse();

//   S.init(n, n);
//   computeSparsity(S);

//   sparsity.set(S);
}

bool MultiAdaptiveIntegrator::integrate(double t0, double &t1)
{
//   if(timestepper == 0)
//     timestepper = new dolfin::TimeStepper(*this, U);

//   //S.clear();
//   //S.init(n, n);
//   //computeSparsity(S);

//   //sparsity.set(S);

//   bool finished = false;
//   while(!finished)
//   {
//     dolfin::real t = timestepper->step();

//     cerr << "t: " << t << endl;

//     interpolatePhysical(t);

//     finished = true;

//     t1 = t;
//   }

//   cerr << "finished" << endl;

  return true;
}

void MultiAdaptiveIntegrator::interpolatePhysical(double t)
{
//   cerr << "interpolatePhysical: " << t << endl;

//   if(t != 0.0)
//   {
//     for(int i = 0; i < n; i++)
//     {
//       U1(i) = U(i, t);
//     }
    
//     fromArray(U1);
//   }
}


void MultiAdaptiveIntegrator::updateLookups()
{
//   elementIndexLookup.clear();
//   indexElementLookup.clear();

//   elementIndexLookup.resize(dynamicElements.size());

//   int i = 0;

//   for(list<Element *>::iterator it = dynamicElements.begin();
//       it != dynamicElements.end(); it++)
//   {
//     Element *e = *it;
      
//     elementIndexLookup[i] = e;
//     indexElementLookup[e] = i;
//     e->index = i;

//     i++;
//   }  
}

void MultiAdaptiveIntegrator::toArray(dolfin::Vector &Ui)
{
//   int i = 0;
//   for(list<Element *>::iterator it = dynamicElements.begin();
//       it != dynamicElements.end(); it++)
//   {
//     Element &e = **it;

//     Ui(3 * i + 0) = e.position(0);
//     Ui(3 * i + 1) = e.position(1);
//     Ui(3 * i + 2) = e.position(2);

//     Ui(n / 2 + 3 * i + 0) = e.velocity(0);
//     Ui(n / 2 + 3 * i + 1) = e.velocity(1);
//     Ui(n / 2 + 3 * i + 2) = e.velocity(2);

//     i++;
//   }  
}

void MultiAdaptiveIntegrator::fromArray(const dolfin::Vector &Ui)
{
//   for(list<Element *>::iterator it = dynamicElements.begin();
//       it != dynamicElements.end(); it++)
//   {
//     Element &e = **it;

//     fromArray(Ui, e);
//   }
}

void MultiAdaptiveIntegrator::fromArray(const dolfin::Vector &Ui, Element &e)
{
//   //int i = indexElementLookup[&e];
//   int i = e.index;

//   e.position(0) = Ui(3 * i + 0);
//   e.position(1) = Ui(3 * i + 1);
//   e.position(2) = Ui(3 * i + 2);
  
//   e.velocity(0) = Ui(n / 2 + 3 * i + 0);
//   e.velocity(1) = Ui(n / 2 + 3 * i + 1);
//   e.velocity(2) = Ui(n / 2 + 3 * i + 2);
}

double MultiAdaptiveIntegrator::u0(unsigned int i)
{
  return U0(i);
}

double MultiAdaptiveIntegrator::timestep(unsigned int i)
{
//   cerr << "k(" << i << "): " << k(i) << endl;

//   return k(i);
//   //if(i == 0)
//   //  return 1e-2;
//   //if(i == 30000)
//   //  return 1e-3;
//   //if(i == 300)
//   //  return 1e-3;
//   //if(i == 120000)
//   //return 2e-3;
//   //if(i == 1200)
//   //return 1e-3;
//   //return 0.1;
}

double MultiAdaptiveIntegrator::f(const dolfin::Vector& Ui, dolfin::real t,
				  unsigned int i)
{
//   //cerr << "f()" << endl;

//   int eIndex;
//   if(i < n / 2)
//     eIndex = i / 3;
//   else
//     eIndex = (i - (n / 2)) / 3;

//   Element &e = *(elementIndexLookup[eIndex]);

//   //cerr << "eIndex: " << eIndex << endl;

//   //cerr << "component: " << i % 6 << endl;
//   //cerr << "t: " << t << endl;

//   fromArray(Ui, e);
//   for(list<Connection *>::iterator it = e.connections.begin();
//       it != e.connections.end(); it++)
//   {
//     Connection &c = **it;

//     Element *e2;
    
//     if(&e == c.element1)
//       e2 = c.element2;
//     else
//       e2 = c.element1;

//     if(!e2->artificial)
//       fromArray(Ui, *e2);
//   }

//   int component = i % 3;
//   if(i < n / 2)
//   {
//     // return component of p' = v

//     //cerr << "vel: " << e.velocity(component) << endl;
//     return e.velocity(component);
//   }
//   else
//   {
//     static Vector force(3), acceleration(3);
    
//     mmodel.force(e, force);
//     e.force = force;

//     // return component of v' = F / m

//     double mass = e.material->density * pow(2 * e.radius, 3);

//     //cerr << "mass: " << mass << endl;
//     acceleration = e.force;
//     acceleration *= 1 / mass;

//     //cerr << "eIndex: " << i << endl;

//     //cerr << "acc: " << acceleration(component - 3) << endl;
//     return acceleration(component);
//   }
}


void MultiAdaptiveIntegrator::computeSparsity(dolfin::Matrix &A)
{
//   int deps = 0;

//   for(list<Element *>::iterator it = dynamicElements.begin();
//       it != dynamicElements.end(); it++)
//   {
//     Element &e = **it;

//     //int i = indexElementLookup[&e];
//     int i = e.index;

//     // Self-dependence

//     A(3 * i + 0, n / 2 + 3 * i + 0) = 1;
//     A(3 * i + 1, n / 2 + 3 * i + 1) = 1;
//     A(3 * i + 2, n / 2 + 3 * i + 2) = 1;
    
//     deps += 3;

//     for(int ii = 0; ii < 3; ii++)
//     {
//       for(int jj = 0; jj < 3; jj++)
//       {
// 	A(n / 2 + 3 * i + ii, 3 * i + jj) = 1;
// 	deps++;
//       }
//       for(int jj = 0; jj < 3; jj++)
//       {
// 	A(n / 2 + 3 * i + ii, n / 2 + 3 * i + jj) = 1;
// 	deps++;
//       }
//     }
    
//     for(list<Connection *>::iterator it = e.connections.begin();
// 	it != e.connections.end(); it++)
//     {
//       Connection &c = **it;
      
//       Element *e2;
      
//       if(&e == c.element1)
// 	e2 = c.element2;
//       else
// 	e2 = c.element1;
      
//       if(!e2->artificial)
//       {
// 	//int j = indexElementLookup[e2];
// 	int j = e2->index;
	
// 	for(int ii = 0; ii < 3; ii++)
// 	{
// 	  for(int jj = 0; jj < 3; jj++)
// 	  {
// 	    A(n / 2 + 3 * i + ii, 3 * j + jj) = 1;
// 	    deps++;
// 	  }
// 	  for(int jj = 0; jj < 3; jj++)
// 	  {
// 	    A(n / 2 + 3 * i + ii, n / 2 + 3 * j + jj) = 1;
// 	    deps++;
// 	  }
// 	}
//       }
//     }
//   }  

//   cerr << "Computed deps: " << deps << endl;
}
