#if !defined(NUMERICALINTEGRATOR_HPP)
#define NUMERICALINTEGRATOR_HPP

#include <list>
#include <map>
#include <set>
#include "ko/LinAlg.hpp"
#include "ko/Element.hpp"
#include "ko/Connection.hpp"
#include "ko/Physical.hpp"

#include "ko/MechanicsModel.hpp"

namespace ko
{

struct NumericalIntegrator
{
public:
  MechanicsModel mmodel;

  Physical &physical;

  NumericalIntegrator(Physical &physical);
  virtual bool integrate(double t0, double &t1) = 0;
  virtual void interpolatePhysical(double t);

  double fixedk;
};

}

#endif // NUMERICALINTEGRATOR_HPP
