#include <strstream>
#include <fstream>
#include <iomanip>

#include "ko/PhysicalDOMTranslator.hpp"
#include "ko/Simulator.hpp"
#include "ko/Physical.hpp"
#include "ko/Element.hpp"

#include "ko/PhysicalManipulator.hpp"

using namespace Behavior;
using namespace std;

ofstream gpos;

void meddle(Simulator &s);




int main(int argC, char* argV[])
{
  if(argC > 1)
  {
    //cerr << "foo" << endl;
    
    double k = 0.03334 / 10.0;
    //double k = 0.002;
    //double k = 0.001;

    dolfin::dolfin_set("output", "plain text");
    dolfin::dolfin_set("tolerance", 0.1);
    dolfin::dolfin_set("number of samples", 1000);
    dolfin::dolfin_set("solve dual problem", false);
    dolfin::dolfin_set("method", "dg");
    dolfin::dolfin_set("order", 0);
    dolfin::dolfin_set("partitioning threshold", 1e-4);

    //dolfin::dolfin_set("initial time step", k);
    //dolfin::dolfin_set("fixed time step", true);
    //dolfin::dolfin_set("maximum time step", k);

    /*
    dolfin::dolfin_set("output", "plain text");
    dolfin::dolfin_set("tolerance", 1e-3);
    dolfin::dolfin_set("method", "dg");
    dolfin::dolfin_set("order", 0);
    dolfin::dolfin_set("initial time step", k);
    */
    //dolfin::dolfin_set("fixed time step", true);
    //dolfin::dolfin_set("maximum time step", k);

    /*
    dolfin::dolfin_set("output", "plain text");
    dolfin::dolfin_set("tolerance", 1e-5);
    dolfin::dolfin_set("number of samples", 1000);
    dolfin::dolfin_set("solve dual problem", false);
    //dolfin::dolfin_set("maximum time step", 1.0);
    //dolfin::dolfin_set("method", "dg");
    //dolfin::dolfin_set("order", 0);
    dolfin::dolfin_set("initial time step", 1e-4);
    dolfin::dolfin_set("fixed time step", true);
    */


    Physical p;

    //s.integrator = s.multiAdaptive;

    //cerr << "bar" << endl;

    PhysicalDOMTranslator t;

    //cerr << "lala" << endl;

    t.parse(argV[1], p);

    //s.insertPhysical(p);
    //Simulator s(p, 50.0);
    Simulator s(p, 10.0);

    cerr << "foo" << endl;
    
    s.integrator = &s.multiAdaptive;


    s.euler.demandConvergence = true;
    s.euler.newtonMaxIters = 30;
    //s.euler.newtonTolerance = 1E-2;
    s.euler.newtonTolerance = 1E-10;

    s.euler.linearMaxIters = 600;
    s.euler.linearTolerance = 1E-3;
    //s.euler.linearTolerance = 1E-10;


    //s.stepsize = 0.03334 / 50.0;
    s.stepsize = k;
    //s.stepsize = 0.1;
    //s.stepsize = 1.0e-02;


    //s.duration = 0.03334 * 1.0;
    //s.duration = 3.0e+00;

    //s.euler.method = BasicEulerIntegrator::FORWARD_EULER;
    s.euler.method = BasicEulerIntegrator::BACKWARD_EULER;

    //s.integrator->mmodel.g(0) = 1 * -9.81 / 1000.0;
    s.integrator->mmodel.g *= 0;

    //s.integrator->mmodel.g(1) = -1 * 9.81 / 1.0;


    /*
      if(s.method == Simulator::FORWARD_EULER)
      gpos.open("forward.dat", ios::out);
      else
      gpos.open("backward2.dat", ios::out);
    */

    //double favg = 0;

    //int counter = 0, fullcounter = 1;
    int counter = 0;
    double lasttime = -1;

    while(s.time < s.duration)
    {
      ///*      
      // 15 fps
      //if(s.time >= (counter * 0.03333 * 2.0))
      ///*
      if(s.time >= (counter * 0.03334))
	//if(s.time >= (counter * 1.0))
      {
	ostrstream filename;
	
	filename.fill('0');
	filename.width(6);
	filename << counter << ".xml" << ends;

	char *fname = filename.str();

	cerr << "writing" << endl;
	cerr << fname << endl;

	ofstream os;
	os.open(fname, ios::out);

	//cerr << s.time << endl;
	t.write(os, s.physical);
	lasttime = s.time;

	counter++;
	os.close();

	delete fname;
      }
      

      cerr << "connections: " << s.physical.connections.size() << endl;
      //*/
      //meddle(s);

      s.step();


      /*
      for(list<Element *>::iterator it = p.elements.begin();
	  it != p.elements.end(); it++)
      {
	Element &e = **it;
	
	std::string target("04");
	if(e.name == target)
	{
	  //cout << "force: " << endl;
	  //print_vector(e.force);

	  double force = two_norm(e.force);
	  favg += force;

	  //cerr << "force: " << force << endl;
	  //cerr << "favg: " << favg / fullcounter << endl;

	}
      }

      fullcounter++;

      */
    }

    /*
    for(int i = 0; i < s.multiAdaptive.n; i++)
    {
      ostrstream solutionString;
      solutionString << "U_" << i << ends;
      s.multiAdaptive.MAsolution.data[i].writeMatlab(cout, solutionString.str());
    }
    
    for(int i = 0; i < s.multiAdaptive.n; i++)
    {
      ostrstream stepString;
      stepString << "k_" << i << ends;
      s.multiAdaptive.MAsteps.data[i].writeMatlab(cout, stepString.str());
    }
    
    for(int i = 0; i < s.multiAdaptive.n; i++)
    {
      ostrstream RString;
      RString << "R_" << i << ends;
      s.multiAdaptive.MAresiduals.data[i].writeMatlab(cout, RString.str());
    }
    
    for(int i = 0; i < s.multiAdaptive.n; i++)
    {
      ostrstream RdString;
      RdString << "Rd_" << i << ends;
      s.multiAdaptive.MAdresiduals.data[i].writeMatlab(cout, RdString.str());
    }
    */
  }

  return 0;
}

double prevtime = 0;

void meddle(Simulator &s)
{
  double stepsize = s.time - prevtime;
  prevtime = s.time;

  for(list<Element *>::iterator it = s.physical.elements.begin();
      it != s.physical.elements.end(); it++)
  {
    Element &e = **it;
	  
    if(e.name == "element 100")
    {

      for(list<Connection *>::iterator it2 =
	    e.connections.begin();
	  it2 != e.connections.end(); it2++)
      {
	Connection &c = **it2;
		  
	if((c.element1->name == "element 100" &&
	    c.element2->name == "element 37") ||
	   (c.element1->name == "element 37" &&
	    c.element2->name == "element 100"))
	{

	}
      }

      //e.position[0] = 0.8;
      e.position(1) -= 1.0 * stepsize;
      //e.position[2] = 0.05;


      e.velocity *= 0;
      e.velocity(1) = -1.0;
      /*
      if(s.time > 0.2 && s.time <= 0.4)
      {
	e.position[0] -= 2 * 0.5 * stepsize;
	e.position[1] -= 2 * 1.3 * stepsize;
      }
      else if(s.time > 1.0 && s.time <= 1.3)
      {
	//e.position[0] -= 0.4 * stepsize;
	//e.position[1] -= 1 * stepsize;

	//e.position[0] = 0.7;
	//e.position[1] = -0.6;

	//e.position[0] -= 3.0 * stepsize;
	//e.position[1] += 0.1 * stepsize;
	//e.position[0] -= 0.5 * stepsize;
	//e.position[0] -= 1.5 * stepsize;
	//e.position[1] += 4.5 * stepsize;

	e.position[1] += 3.5 * stepsize;
      }
      */
    }
  }

  /*
  if(target != 0)
  {
    Connection *ctarget = 0;

    for(list<Connection *>::iterator it = target->connections.begin();
    it != target->connections.end();)
    {
    Connection &c = **it;

    it++;
	      
    if((c.element1->name == "element 100" &&
    c.element2->name == "element 37") ||
    (c.element1->name == "element 37" &&
    c.element2->name == "element 100"))
    {
    ctarget = &c;
    }
    }

    if(ctarget != 0)
    {
    cerr << "DISCONNECT" << endl;
    ctarget->disconnect();
    s.physical.connections.remove(ctarget);
    //ctarget->hooke = 0.0;
    }
    }
    }

  */

  /*
    Element *target = 0;
  
    for(list<Element *>::iterator it = s.physical.elements.begin();
    it != s.physical.elements.end(); it++)
    {
    Element &e = **it;
      
    if(e.name == "bar")
    {
    cerr << e.name << endl;
    target = &e;
    }
    }

    gpos << s.time << " " <<
    target->position[0] << " " <<
    target->position[1] << " " <<
    target->position[2] << " " <<
    endl;
  */
}
