#!/bin/sh

DOLFIN_VERSION=`dolfin-config --version`
CFLAGS=`dolfin-config --cflags`
TIMEFORMAT='real: %3R  user: %3U  sys: %3S  cpu: %P%%'

echo "Date: " $( date )
uname -a

echo
echo "Multi-Stiff 1 (b = 1) - Ko"

echo -n "Elapsed time:   "
time ko/ko-test3 ko/5x2x1-beam14b.xml > log1_1 2> log2_1
mv primal.m ko1_primal.m
mkdir -p output1
mv 0*.xml output1

echo
echo "Multi-Stiff 2 (b = 100, disjoint) - Ko"

echo -n "Elapsed time:   "
time ko/ko-test3 ko/5x2x1-beam15.xml > log1_2 2> log2_2
mv primal.m ko2_primal.m
mkdir -p output2
mv 0*.xml output2

echo
echo "Multi-Stiff 3 (b = 10) - Ko"

echo -n "Elapsed time:   "
time ko/ko-test3 ko/5x2x1-beam14.xml > log1_3 2> log2_3
mv primal.m ko3_primal.m
mkdir -p output3
mv 0*.xml output3

echo
echo "Multi-Stiff 4 (b = 100) - Ko"

echo -n "Elapsed time:   "
time ko/ko-test3 ko/5x2x1-beam14c.xml > log1_4 2> log2_4
mv primal.m ko4_primal.m
mkdir -p output4
mv 0*.xml output4

echo
echo "Multi-Stiff 5 (b = 1000) - Ko"

echo -n "Elapsed time:   "
time ko/ko-test3 ko/5x2x1-beam14d.xml > log1_5 2> log2_5
mv primal.m ko5_primal.m
mkdir -p output5
mv 0*.xml output5

