#include <strstream>
#include <fstream>
#include <iomanip>
#include <sstream>

#include <sys/time.h>

#include "ko/PhysicalDOMTranslator.hpp"
#include "ko/Simulator.hpp"
#include "ko/Physical.hpp"
#include "ko/Element.hpp"

#include "ko/PhysicalManipulator.hpp"

using namespace Behavior;
using namespace std;

ofstream gpos;

// Construct the problem

void construct(Physical &physical, int n);

int main(int argC, char* argV[])
{
  int n = 100;
  int m = 100;
  std::string method = "multi";

  if(argC > 1)
  {
    n = atoi(argV[1]);
  }
  if(argC > 2)
  {
    m = atoi(argV[2]);
  }
  if(argC > 3)
  {
    std::string arg = argV[3];
    if(arg == "multi")
      method = arg;
    if(arg == "mono")
      method = arg;
  }
  //cerr << "foo" << endl;
  
  //double k = 0.03334 / 10.0;
  //double k = 0.002;
  //double k = 1e-3;
  //double k = 1e-2;
  double k = 0.1 / m;
  
  dolfin::dolfin_set("output", "plain text");
  //dolfin::dolfin_set("tolerance", 0.01);
  //dolfin::dolfin_set("tolerance", 0.00001);
  //dolfin::dolfin_set("tolerance", 0.0001);
  //dolfin::dolfin_set("tolerance", 0.00001);
  //dolfin::dolfin_set("tolerance", 1e-6);
  //dolfin::dolfin_set("tolerance", 1.0);
  dolfin::dolfin_set("tolerance", 1.0e-4);
  dolfin::dolfin_set("number of samples", 111);
  //dolfin::dolfin_set("maximum convergence", 2.0);
  //dolfin::dolfin_set("solve dual problem", false);
  dolfin::dolfin_set("solve dual problem", false);
  dolfin::dolfin_set("method", "dg");
  dolfin::dolfin_set("order", 0);
  //dolfin::dolfin_set("method", "cg");
  //dolfin::dolfin_set("order", 1);
  //dolfin::dolfin_set("element cache size", 1000);
  
  
  //dolfin::dolfin_set("partitioning threshold", 1e-7);
  //dolfin::dolfin_set("partitioning threshold", 0.2);
  //dolfin::dolfin_set("partitioning threshold", 0.5);
  dolfin::dolfin_set("partitioning threshold", 0.99);
  //dolfin::dolfin_set("stiffness", "stiff level 3");
  dolfin::dolfin_set("debug iterations", false);
  dolfin::dolfin_set("maximum iterations", 20000);
  //dolfin::dolfin_set("maximum time step", k);
  
  //dolfin::dolfin_set("initial time step", 1e-6);
  dolfin::dolfin_set("initial time step", 0.1);
  dolfin::dolfin_set("fixed time step", true);
  //dolfin::dolfin_set("maximum time step", k);
  dolfin::dolfin_set("save solution", false);
  //dolfin::dolfin_set("save solution", false);
  
  /*
    dolfin::dolfin_set("output", "plain text");
    dolfin::dolfin_set("tolerance", 1e-3);
    dolfin::dolfin_set("method", "dg");
    dolfin::dolfin_set("order", 0);
  */
  //dolfin::dolfin_set("maximum time step", k);
  //dolfin::dolfin_set("fixed time step", true);
  //dolfin::dolfin_set("initial time step", k);
  
  /*
    dolfin::dolfin_set("output", "plain text");
    dolfin::dolfin_set("tolerance", 1e-5);
    dolfin::dolfin_set("number of samples", 1000);
    dolfin::dolfin_set("solve dual problem", false);
    //dolfin::dolfin_set("maximum time step", 1.0);
    //dolfin::dolfin_set("method", "dg");
    //dolfin::dolfin_set("order", 0);
    dolfin::dolfin_set("initial time step", 1e-4);
    dolfin::dolfin_set("fixed time step", true);
  */
  
  
  Physical p;
  
  //s.integrator = s.multiAdaptive;
  
  //cerr << "bar" << endl;

  PhysicalDOMTranslator t;

  //cerr << "lala" << endl;

  //t.parse(argV[1], p);

  //construct(p, 100);
  construct(p, n);

  //s.insertPhysical(p);
  //Simulator s(p, 50.0);
  Simulator s(p, 1.0);

  cerr << "foo" << endl;
    

  if(method == "multi")
    s.integrator = &s.multiAdaptive;
  if(method == "mono")
    s.integrator = &s.euler;

  s.multiAdaptive.k(0) = 0.1 / m;
  s.multiAdaptive.k(3 * n) = 0.1 / m;


  s.euler.demandConvergence = true;
  s.euler.newtonMaxIters = 30;
  s.euler.newtonTolerance = 1E-8;

  s.euler.linearMaxIters = 600;
  s.euler.linearTolerance = 1E-3;

  s.stepsize = k;

  s.euler.method = BasicEulerIntegrator::FORWARD_EULER;
  //s.euler.method = BasicEulerIntegrator::BACKWARD_EULER;

  //s.integrator->mmodel.g(0) = 1 * -9.81 / 1000.0;
  s.integrator->mmodel.g *= 0;

  //s.integrator->mmodel.g(1) = -1 * 9.81 / 1.0;


  struct timeval before, after;
  double elapsed, t1;
  gettimeofday(&before, NULL);

  int counter = 0;
  double lasttime = -1;

  while(s.time < s.duration)
  {
    ///*
    // 15 fps
    //if(s.time >= (counter * 0.03333 * 2.0))

    while(s.time >= (counter * 0.03334))
    {
    s.integrator->interpolatePhysical(counter * 0.03334);

    ostrstream filename;
	
    filename.fill('0');
    filename.width(6);

    filename << counter << ".xml" << ends;

    char *fname = filename.str();

    cerr << "writing" << endl;
    cerr << fname << endl;

    ofstream os;
    os.open(fname, ios::out);

    t.write(os, s.physical);

    lasttime = s.time;

    counter++;
    os.close();

    delete fname;
    }
      

    cerr << "connections: " << s.physical.connections.size() << endl;

    s.integrator->interpolatePhysical(s.time);
    //*/

    s.step();



  }

  gettimeofday(&after, NULL);
    
  elapsed = (1E6 * after.tv_sec + after.tv_usec) -
    (1E6 * before.tv_sec + before.tv_usec);
    
  cerr << "simulate: " << elapsed << endl;


  return 0;
}

void construct(Physical &p, int n)
{
  Material *m1 = new Material;
  Material *m2 = new Material;

  m1->young = 1e1;
  m1->density = 1e3;
  m1->name = "material";

  m2->young = 2e3;
  m2->density = 1e3;
  m2->name = "hard";

  p.materials.push_back(m1);
  p.materials.push_back(m2);

  Element *fixed = new Element;
  fixed->artificial = true;
  fixed->radius = 5e-2;
  fixed->material = m2;
  fixed->name = "fixed";
  p.addElement(*fixed);

  Element *e0 = new Element;
  e0->artificial = false;
  e0->radius = 5e-2;
  e0->material = m1;
  e0->position(0) = 5e-2;
  e0->name = "0";
  p.addElement(*e0);

  Connection *c0 = new Connection;
  c0->connect(*e0, *fixed);
  c0->length = 0;
  p.addConnection(*c0);

  Element *elements[n - 1];

  for(int i = 0; i < n - 1; i++)
  {
    Element *e = new Element;
    std::ostringstream namestream;

    elements[i] = e;

    namestream << (i + 1);

    e->name = namestream.str();
    e->radius = 5e-2;
    e->material = m1;
    e->position(0) = (i + 1) * 1e-1;

    p.addElement(*e);
  }

  for(int i = 0; i < n - 2; i++)
  {
    Connection *c = new Connection;
    c->connect(*elements[i], *elements[i + 1]);
    c->length = 1e-1;
    p.addConnection(*c);
  }

  if(n > 1)
  {
    Connection *c1 = new Connection;
    c1->connect(*e0, *elements[0]);
    c1->length = 1e-1;
    p.addConnection(*c1);
  }
}

