#!/bin/sh

function run()
{
/usr/bin/time -f"$TIMEFORMAT" -otlog ./ko-performance-stiff $1 $2 $3 1> /dev/null 2> /dev/null
TIME=$( cat tlog )
echo "Elapsed time:   " $TIME
echo -n $( echo $TIME | awk '{ print $4 }' ) " + " $( echo $TIME | awk '{ print $6 }' ) >> timings.m
echo -n " " >> timings.m
echo
}


DATE=`date`
TIMEFORMAT='real: %e  user: %U  sys: %S  cpu: %P%%'

echo
echo "Ko Performance Test: Stiff problems"
echo
echo "---------------------------------------------------------------------------"
uname -a
echo "---------------------------------------------------------------------------"

#N="10 20 40 100 200 400"
#b="100 200 400 800 1000 1100 1200 1300 1400 1500 1600 1700 1800 1900 2000"
b="10 20 40 80 160 320 640 1280 2560 5120"
#b="10 15 20 30 40 60 80 120 160 240 320 480 640 960 1280 1920 2560 3840 5120 7680 10240"


if [ "$1" = "" ]; then

N=100

else

N=$1

fi

echo "b = "$b

echo

#N="100 200 400"
#N="4 8 16"

echo "N = [ " $N "];" > timings.m
echo "b = [ " $b "];" > timings.m


#echo -n "t_mcg1 = [" >> timings.m

#for i in $N
#do

#echo "mcG(1) n = " $i
#run $i mcg

#done

#echo

#echo "]" >> timings.m


echo -n "t_stab = [" >> timings.m

for i in $b
do

echo "Stabilized fixed point N = " $N, " b = " $i
run $N $i stab

done

echo "];" >> timings.m

echo

echo -n "t_newton = [" >> timings.m

for i in $b
do

echo "Newton (GMRES) N = " $N " b = " $i
run $N $i newton

done

echo "]" >> timings.m

echo

echo -n "t_nostab = [" >> timings.m

for i in $b
do

echo "Unstabilized fixed point N = " $N " b = " $i
run $N $i nostab

done

echo "]" >> timings.m

echo


echo "---------------------------------------------------------------------------"
