#include <math.h>
#include <iostream>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/SoPath.h>

#include "ko/GeometryFiller.hpp"
#include "ko/PhysicalDOMTranslator.hpp"

#include "ko/InventorGTSTranslator.hpp"

#include <gts.h>

using namespace ko;
using namespace std;

int main(int argC, char* argV[])
{
  bool center = false;

  double density = 10;

  if(argC > 2)
  {
    density = strtod(argV[2], NULL);
    
    cerr << "density: " << density << endl;
  }
  
  if(argC > 3)
  {
    std::string centerString = argV[3];
    if(centerString == "center")
    {
      center = true;
    }
  }
  
  if(argC > 1)
  {
    
    GtsSurface *surface;
    
    /*
      surface = gts_surface_new (gts_surface_class(),
      gts_face_class(),
      gts_edge_class(),
      gts_vertex_class());
      
      FILE *fp = fopen(argV[1], "r");
      if(fp == NULL)
      {
      cerr << "Cannot open file" << endl;
      exit(1);
      }
      
      int retval = gts_surface_read(surface, fp);
      if(retval != 0)
      {
      cerr << "GTS parse error" << endl;
      exit(1);
      }
    */

    
    
    
    InventorGTSTranslator translator;
    
    SoInput mySceneInput;
    
    SoSeparator *rootSeparator;
    
    if(!mySceneInput.openFile(argV[1]))
    {
      fprintf(stderr, "Cannot open file\n");
      exit(1);
    }
    
    rootSeparator = SoDB::readAll(&mySceneInput);
    if(rootSeparator == NULL)
    {
      fprintf(stderr, "problems with graph\n");
      exit(1);
    }
    
    SoPath *rootPath = new SoPath(rootSeparator);
    rootPath->ref();
    
    //GtsSurface *surface;
    
    translator.translate(rootPath, &surface);
    //translator.write(stdout, surface);
    
    
    
    GeometryFiller filler;
    
    filler.init(surface);
    
    filler.fill(density, center);
    
    PhysicalDOMTranslator t;
    
    t.write(cout, filler.physical);
    
    
  }
  
  return 0;
}
