#include <math.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/SoPath.h>

#include "ko/InventorGTSTranslator.hpp"

using namespace ko;
using namespace std;

int main(int argC, char* argV[])
{
  if(argC > 1)
    {
      InventorGTSTranslator translator;

      SoInput mySceneInput;
      
      SoSeparator *rootSeparator;
      
      if(!mySceneInput.openFile(argV[1]))
      {
	fprintf(stderr, "Cannot open file\n");
	exit(1);
      }
      
      rootSeparator = SoDB::readAll(&mySceneInput);
      if(rootSeparator == NULL)
      {
	fprintf(stderr, "problems with graph\n");
	exit(1);
      }
      
      SoPath *rootPath = new SoPath(rootSeparator);
      rootPath->ref();

      GtsSurface *surface;

      translator.translate(rootPath, &surface);
      translator.write(stdout, surface);

    }

  return 0;
}
