#if !defined(GEOMETRYFILLER_HPP)
#define GEOMETRYFILLER_HPP

#include <list>
#include <string>

#include <gts.h>

#include "ko/LinAlg.hpp"
#include "ko/Physical.hpp"
#include "ko/Element.hpp"

namespace ko
{

class GeometryFiller
{
public:
  Physical physical;

  GNode *bbTree;

  GtsPoint *probePoint;

  GeometryFiller();

  void init(GtsSurface *surface);
  void fill(double density, bool center);
  bool inside(Vector &p);
  static void weld(Physical &physical, double distance);
};

}

#endif
