#if !defined(GEOMETRYMESHER_HPP)
#define GEOMETRYMESHER_HPP

#include <list>
#include <string>

#include <gts.h>

#include <dolfin/Mesh.h>

#include "ko/LinAlg.hpp"
#include "ko/Physical.hpp"
#include "ko/Element.hpp"

namespace ko
{

class GeometryMesher
{
public:
  dolfin::Mesh mesh;

  GNode *bbTree;

  GtsPoint *probePoint;

  GeometryMesher();

  void init(GtsSurface *surface);
  void meshgen(double density, bool center);
  bool inside(Vector &p);
};

}

#endif
