#include <math.h>

#include <Inventor/SbLinear.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoSphere.h>
#include <Inventor/nodes/SoCylinder.h>
#include <Inventor/nodes/SoComplexity.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/SoOutput.h>

#include "ko/PhysicalDOMTranslator.hpp"
#include "ko/Physical.hpp"
#include "ko/Element.hpp"
#include "ko/LinAlg.hpp"

#include "ko/PhysicalInventorInterface.hpp"


using namespace ko;
using namespace std;

int main(int argC, char* argV[])
{
  dolfin::dolfin_output("silent");

  if(argC > 1)
    {
      Physical p;

      PhysicalDOMTranslator t;

      t.parse(argV[1], p);

      PhysicalInventorInterface interface;

      //writePhysicalIv(p);
      for(list<Element *>::iterator i = p.elements.begin();
	  i != p.elements.end(); i++)
      {
	Element &e = **i;

	interface.addElement(e);
      }

      for(list<Connection *>::iterator i = p.connections.begin();
	  i != p.connections.end(); i++)
      {
	Connection &c = **i;
	
	Element &e1 = *(c.element1);
	Element &e2 = *(c.element2);

	interface.addConnection(c);
      }
      
      interface.updateSceneGraph();

      SoOutput out;
      out.setFilePointer(stdout);
      
      SoWriteAction wa(&out);
      wa.apply(interface.rootSeparator);

    }

  return 0;
}
