#include <strstream>
#include <fstream>
#include <iomanip>

#include "ko/PhysicalDOMTranslator.hpp"
#include "ko/Physical.hpp"
#include "ko/Element.hpp"

using namespace ko;
using namespace std;

void transform(Physical &p)
{
  Vector pmin(3), pmax(3);
  double psize;

  /*
  for(list<Element *>::iterator it = p.elements.begin();
      it != p.elements.end(); it++)
  {
    Element &e = **it;

    e.velocity = 0;
    e.velocity(1) = -0.1;
  }
  */

  for(list<Element *>::iterator it = p.elements.begin();
      it != p.elements.end(); it++)
  {
    Element &e = **it;

    if(it == p.elements.begin())
    {
      pmin = e.position;
      pmax = e.position;
    }
    else
    {
      pmin(0) = min(e.position(0), pmin(0));
      pmin(1) = min(e.position(1), pmin(1));
      pmin(2) = min(e.position(2), pmin(2));

      pmax(0) = max(e.position(0), pmax(0));
      pmax(1) = max(e.position(1), pmax(1));
      pmax(2) = max(e.position(2), pmax(2));

    }
  }

  //print_vector(pmin);
  //print_vector(pmax);

  Vector tmp(3);
  tmp = pmin;
  tmp.axpy(-1, pmax);
  psize = tmp.norm();

  Vector center(3);

  center = pmin;
  center.axpy(1, pmax);
  center *= 0.5;


  Vector com(3);

  for(list<Element *>::iterator it = p.elements.begin();
      it != p.elements.end(); it++)
  {
    Element &e = **it;

    com.axpy(1, e.position);
  }

  com *= 1.0 / p.elements.size();

  Vector avel(3), relpos(3);

  avel(2) = 0.1;

  for(list<Element *>::iterator it = p.elements.begin();
      it != p.elements.end(); it++)
  {
    Element &e = **it;

//     if(e.position(0) < -0.2 && e.position(1) > -0.1)
//     {
//       e.artificial = true;
//     }

//     e.velocity = 0;

//     e.velocity(0) = 1.0;

    /*
    relpos = com;
    relpos.add(-1, e.position);

    cross(avel, relpos, e.velocity);
    */

    if(e.position(0) >= 1.5)
    {
      e.velocity(0) = 1.0;
    }
    else if(e.position(0) <= 0.5)
    {
      e.velocity(0) = -1.0;
    }
  }

  /*
  for(list<Element *>::iterator it = p.elements.begin();
      it != p.elements.end(); it++)
  {
    Element &e = **it;

    Vector distance(3), point(3);
    point(0) = pmin(0);
    point(1) = pmax(1);
    distance = point;
    distance.add(-1, e.position);
    distance(2) = 0;

    cerr << "foo: " << distance.norm() << " " << psize << endl; 

    if(distance.norm() < 0.2 * psize)
    {
      e.artificial = true;
    }
  }
  */
}

int main(int argC, char* argV[])
{
  dolfin::dolfin_output("silent");

  if(argC > 1)
  {
    Physical p;

    PhysicalDOMTranslator t;

    t.parse(argV[1], p);

    transform(p);
 
    t.write(cout, p);
 }
  return 0;
}


